import { NgModule } from "@angular/core";
import { ReactiveFormsModule, FormsModule } from "@angular/forms";
import { CommonModule } from "@angular/common";
import { HttpClientModule } from "@angular/common/http";

import { FocusRegisterDirective } from "./directive/focus-register.directive";

import * as fromComponents from "./component";
import * as fromPipes from "./pipe";

import * as newComponents from "./component/form";

import { SharedModule as primeSharedModule } from "primeng/components/common/shared";
import { CalendarModule } from "primeng/components/calendar/calendar";
import { DropdownModule } from "primeng/components/dropdown/dropdown";
import { EditorModule } from "primeng/components/editor/editor";
import { MultiSelectModule } from "primeng/components/multiselect/multiselect";
import { PaginatorModule } from "primeng/components/paginator/paginator";
import { CheckboxModule } from "primeng/components/checkbox/checkbox";
import { RadioButtonModule } from "primeng/components/radiobutton/radiobutton";
import { DataTableModule } from "primeng/components/datatable/datatable";
import { TableModule } from "primeng/table";
import { TabViewModule } from "primeng/components/tabview/tabview";
import { DialogModule } from "primeng/components/dialog/dialog";
import { AccordionModule } from "primeng/components/accordion/accordion";
import { AutoCompleteModule } from "primeng/components/autocomplete/autocomplete";
import { InputSwitchModule } from "primeng/components/inputswitch/inputswitch";
import { TooltipModule } from "primeng/components/tooltip/tooltip";
import { OverlayPanelModule } from "primeng/components/overlaypanel/overlaypanel";
import { MessagesModule } from "primeng/components/messages/messages";
import { MenuModule } from "primeng/components/menu/menu";
import { MenubarModule } from "primeng/components/menubar/menubar";
import { MegaMenuModule } from "primeng/components/megamenu/megamenu";
import { GrowlModule } from "primeng/components/growl/growl";

const modules: any[] = [
  CommonModule,
  ReactiveFormsModule,
  FormsModule,
  HttpClientModule,
  CalendarModule,
  DropdownModule,
  EditorModule,
  MultiSelectModule,
  PaginatorModule,
  CheckboxModule,
  RadioButtonModule,
  DataTableModule,
  TableModule,
  TabViewModule,
  DialogModule,
  MenuModule,
  MegaMenuModule,
  MenubarModule,
  GrowlModule,
  primeSharedModule,
  AccordionModule,
  AutoCompleteModule,
  InputSwitchModule,
  TooltipModule,
  OverlayPanelModule,
  MessagesModule
];

@NgModule({
  imports: [...modules],
  declarations: [FocusRegisterDirective, ...fromComponents.components, ...fromPipes.pipes],
  exports: [...modules, FocusRegisterDirective, ...fromPipes.pipes, ...fromComponents.components]
})
export class SharedModule {}
